

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "csound.hpp"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;

int main(int argc, char *argv[])
{
Csound *csound;
int k,res, result;
csound = new Csound;
PVSDATEXT dataout;
FILE *outf;

csound->PreCompile();
result = csound->Compile ("pvsouttest.csd");

//new in csound5.12.  This will print num of frames
dataout.N = 0; //or dataout.N = -2;

    //do one ksmps pass to init structure variables
    //and create memory
    while (!result)
    {
      result = csound->PerformKsmps();
      csound->PvsoutGet(&dataout, 1);
      dataout.frame = new float[dataout.N+2];
      result = -1;
    }

//print structure values to screen
cout<<"Accessing structure elements:";
cout <<"\n\'dataout.N\'  = "<< dataout.N;
cout <<"\n\'dataout.sliding\'  = "<< dataout.sliding;
cout <<"\n\'dataout.NB\'  = "<< dataout.NB;
cout <<"\n\'dataout.overlap\'  = "<< dataout.overlap;
cout <<"\n\'dataout.winsize\'  = "<< dataout.winsize;
cout <<"\n\'dataout.wintype\'  = "<< dataout.wintype;
cout <<"\n\'dataout.format\'  = "<< dataout.format;
cout <<"\n\'dataout.framecount\'  = "<< dataout.framecount;

//reset result
result = 0;
//++++++++++
//write audio frames only to file
//using c fprintf with 'g' flag
//print csv(comma sep values) alternating amp/freq values

outf = fopen("Erhu.txt", "w");
    while (!result)
    {
        for (k=0; k<1026; k++)
	fprintf(outf, "%g,", dataout.frame[k]);
      	//one ksmps pass
      	result = csound->PerformKsmps();
      	//get the data
      	csound->PvsoutGet(&dataout, 1);//channel 1
     }
//ck. num of frames
cout<<"\n dataout - last framecount = " <<dataout.framecount;
     fclose(outf);
    /* delete Csound instance */
    delete csound;
    //free memory
    free(dataout.frame);
    return (result >= 0 ? 0 : result);
} //end main
